<template>
  <div class="q-pa-md">
    <div class="order-subtitle q-px-lg">
      <h5 class="text-h5">Verifica comanda</h5>
      <q-separator />
    </div>
    <div class="row q-my-lg q-px-lg">
      <div class="col-xs-12 col-sm-6 col-6 order-summary q-pa-lg">
        <p class="text-subtitle1 text-weight-medium">Adresa de facturare</p>
        <q-separator />
        <p class="q-mt-sm text-weight-medium">{{ fullName }}</p>
        <p>{{fullAddress}}</p>
      </div>
      <div class="col-xs-12 col-sm-6 col-6 order-summary q-pa-lg">
        <p class="text-subtitle1 text-weight-medium">Date de facturare</p>
        <q-separator />
        <div v-if="isOnlinePayment">
          <p class="q-mt-sm text-weight-medium">Plata online</p>
          <p class="q-mt-sm">Plata se va efectua dupa finalizarea comenzii.</p>
        </div>
        <div v-else>
          <p class="q-mt-sm text-weight-medium">Ramburs la curier</p>
          <p class="q-mt-sm">Vei plati in momentul in care comanda va fi livrata.</p>
        </div>
      </div>
    </div>

    <div v-for="(product, index) in shoppingCart" :key="product.id" class="q-px-lg q-my-lg">
      <div class="row q-px-sm justify-between">
        <div class="row">
          <p>{{index+1}}&nbsp;</p>
          <q-separator vertical inset />
          <p>
            <span class="text-primary">&nbsp;{{product.quantity}}&nbsp;x</span>
            &nbsp;&nbsp;&nbsp;{{product.detail.name}}, {{product.preference.color}}, {{product.preference.size}}
          </p>
        </div>

        <p class="text-subtitle1 text-weight-medium">{{product.quantity * product.detail.price}} RON</p>
      </div>
    </div>
    <div class="q-px-lg q-my-lg">
      <div class="row q-px-sm justify-between">
        <p class="text-weight-medium">Cost livrare si procesare</p>

        <p class="text-subtitle1 text-weight-medium">{{deliveryPrice}} RON</p>
      </div>
    </div>
    <div v-if="voucher" class="text-primary q-px-lg q-my-lg">
      <div class="row q-px-sm justify-between">
        <p class="text-weight-medium">
          Discount ({{voucher.value}}
          <span v-if="voucher.type === 'percent'">%</span>
          <span v-else>RON</span>)
        </p>

        <p
          class="text-subtitle1 text-weight-medium"
        >- {{(totalPurchasePrice + deliveryPrice - finalValue).toFixed(2)}} RON</p>
      </div>
    </div>
    <div class="column justify-center items-center margin-lg">
      <h4 class="text-h4 text-weight-medium text-center">Total comanda: {{ finalValue }} RON</h4>
      <p class="text-caption text-center">{{ disclaimer }}</p>
      <q-btn
        @click="finishOrder"
        class="q-mb-lg"
        unelevated
        color="primary"
        label="TRIMITE COMANDA"
        size="xl"
      />
      <div class="row">
        <q-btn @click="goBackToCart" flat no-caps style="color: #818078" label="Inapoi la cos" />
        <q-btn
          @click="goBackToBilling"
          flat
          no-caps
          style="color: #818078"
          label="Inapoi la facturare"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { LocalStorage } from "quasar";

export default {
  name: "review",
  data() {
    return {
      deliveryPrice: 20,
      disclaimer:
        "Prin plasarea comenzii, esti de acord cu Termenii si Conditiile si Politica de confidentialitate.",
    };
  },
  computed: {
    fullName() {
      return this.details.firstName + " " + this.details.lastName;
    },
    totalPurchasePrice() {
      return this.shoppingCart.reduce(function (accumulator, item) {
        return accumulator + item.quantity * item.detail.price;
      }, 0);
    },
    shoppingCart() {
      return this.$store.getters["adminData/getShoppingCart"];
    },
    isOnlinePayment() {
      return this.$store.getters["adminData/getOnlinePayment"];
    },
    voucher() {
      return this.$store.getters["adminData/getVoucher"];
    },
    finalValue() {
      let value = this.totalPurchasePrice;
      if (this.voucher) {
        if (this.voucher.type == "percent")
          value = value - (value * this.voucher.value) / 100;
        else value = value - this.voucher.value;
      }

      return value > 0 ? value + this.deliveryPrice : this.deliveryPrice;
    },
    details() {
      return LocalStorage.getItem("user");
    },
    fullAddress() {
      if (
        this.details.address &&
        this.details.city &&
        this.details.state &&
        this.details.zip
      )
        return (
          this.details.address +
          ", " +
          this.details.city +
          ", " +
          this.details.state +
          ", " +
          this.details.zip
        );
      else return "Nu ai introdus o adresa!";
    },
  },
  methods: {
    finishOrder() {
      this.$axios
        .post("/api/purchases", {
          onlinePayment: this.isOnlinePayment,
          code: this.voucher ? this.voucher.code : null,
        })
        .then((response) => {
          this.$q.notify({
            message: response.data.message,
            color: "positive",
          });
          this.$router.push({ name: "success" });
          this.$store.dispatch("adminData/loadShoppingCart");
          this.$store.dispatch("adminData/loadCurrentUserProducts");
        })
        .catch((err) => {
          this.$q.notify({
            color: "negative",
            message: err.response.data.message,
            icon: "report_problem",
          });
        });
    },
    goBackToCart() {
      this.$router.push({ name: "cart" });
    },
    goBackToBilling() {
      this.$router.push({ name: "billing" });
    },
  },
};
</script>

<style lang="scss" scoped>
.order-summary {
  background-color: #f2f2f2;
}
.info-subtitle,
.product-price,
.order-total {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
</style>
